﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace tpts.Logging
{
    /// <summary>
    /// Logger to log items to the console window inside the IDE.
    /// </summary>
    /// <typeparam name="T">The type of item to log.</typeparam>
    public class ConsoleLogger<T>:Logger<T>
    {

        #region Declarations
        #endregion

        #region Constructors
        #endregion

        #region Properties
        #endregion

        #region Public Methods
        #endregion

        #region Protected Methods
        #endregion

        #region Private Methods
        #endregion

        #region Logger

        /// <summary>
        /// Log the entry
        /// </summary>
        /// <param name="logEntry"></param>
        /// <returns>A boolean indicating if the item was logged or not.</returns>
        /// <remarks>
        /// Contract: pre  : logEntry must not be null.
        /// </remarks>
        protected override bool Log(LogEntry<T> logEntry)
        {
            // Check log entry matches filter.
            if (CheckFilter(logEntry))
            {
                // Apply formatting
                string formattedEntry = FormatEntry(logEntry);

                // Write to console.
                Console.WriteLine(formattedEntry);

                return true;
            }
            else
            {
                return false;
            }
        }

        #endregion

    }


}
