﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace tpts.Logging
{
    /// <summary>
    /// Interface for file name rollover strategies for File Loggers.
    /// </summary>
    [ContractClass(typeof(IFileRolloverStrategyContract))]	 // Specify class that contains contracts
    public interface IFileRolloverStrategy
    {

        #region Declarations
        #endregion

        #region Constructors
        #endregion

        #region Properties
        #endregion

        #region Public Methods

        /// <summary>
        /// Get the rolled file name based on the supplied file name.
        /// </summary>
        /// <param name="fileName"></param>
        /// <returns></returns>
        /// <remarks>
        /// Contract: pre  : fileName must not be null or empty or contain just whitespaces.
        ///           post : Result will not be null or empty or contain just whitespaces.
        /// </remarks>
        string GetRolledFileName(string fileName);

        #endregion

        #region Protected Methods
        #endregion

        #region Private Methods
        #endregion

    }


}
