﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace tpts.Logging
{
    /// <summary>
    /// Interface for a log entry filter for the specified object type.
    /// </summary>
    /// <typeparam name="T">The type of item logged.</typeparam>
    [ContractClass(typeof(ILogEntryFilterContract<>))]	 // Specify class that contains contracts
    public interface ILogEntryFilter<T>
    {
        /// <summary>
        /// Does the log entry pass the filter criteria.
        /// </summary>
        /// <param name="logEntry"></param>
        /// <returns>A boolean indicating if the log entry passes the filter criteria.</returns>
        /// <remarks>
        /// Contract: pre  : logEntry must not be null.
        /// </remarks>
        bool Accept(LogEntry<T> logEntry);

    }
}
