﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace tpts.Logging
{
    /// <summary>
    /// Contract class for interface ILogEntryFilter
    /// </summary>
    [ContractClassFor(typeof(ILogEntryFilter<>))]
    internal abstract class ILogEntryFilterContract<T> : ILogEntryFilter<T>
    {

        /// <summary>
        /// Contract for ILogEntryFilter.Accept
        /// </summary>
        /// <param name="logEntry"></param>
        /// <returns></returns>
        /// <remarks>
        /// Contract: pre  : logEntry must not be null.
        /// </remarks>
        public bool Accept(LogEntry<T> logEntry)
        {
            Contract.Requires(logEntry != null);

            return default(bool); 
        }
    }
 }
