﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace tpts.Logging
{
    /// <summary>
    /// Interface for a log entry formatter for the specified object type.
    /// </summary>
    /// <typeparam name="T">The type of item logged.</typeparam>
    [ContractClass(typeof(ILogEntryFormatterContract<>))]	 // Specify class that contains contracts
    public interface ILogEntryFormatter<T>
    {

        /// <summary>
        /// Format the log entry.
        /// </summary>
        /// <param name="logEntry"></param>
        /// <returns>A string.</returns>
        /// <remarks>
        /// Contract: pre  : logEntry must not be null.
        /// </remarks>
        string FormatEntry(LogEntry<T> logEntry);

    }
}
