﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace tpts.Logging
{
    /// <summary>
    /// Contract class for interface ILogEntryFormatterContract
    /// </summary>
    [ContractClassFor(typeof(ILogEntryFormatter<>))]
    internal abstract class ILogEntryFormatterContract<T> : ILogEntryFormatter<T>
    {

        /// <summary>
        /// Contract for ILogEntryFormatter.FormatEntry
        /// </summary>
        /// <param name="logEntry"></param>
        /// <returns></returns>
        /// <remarks>
        /// Contract: pre  : logEntry must not be null.
        ///           post : Result will not be null.
        /// </remarks>
        public string FormatEntry(LogEntry<T> logEntry)
        {
            Contract.Requires(logEntry != null);
            Contract.Ensures(Contract.Result<string>() != null);

            return default(string);
        }
    }
}
