﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace tpts.Logging
{
    /// <summary>
    /// Contract class for interface Logger
    /// </summary>
    [ContractClassFor(typeof(Logger<>))]
    internal abstract class LoggerContract<T> : Logger<T>
    {


        /// <summary>
        /// Log the entry
        /// </summary>
        /// <param name="logEntry"></param>
        /// <returns>A boolean indicating if the item was logged or not.</returns>
        /// <remarks>
        /// Contract: pre  : logEntry must not be null.
        /// </remarks>
        protected override bool Log(LogEntry<T> logEntry)
        {
            Contract.Requires(logEntry != null);

            return default(bool);
        }
    }
}
