﻿using tpts.Logging;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace tptsLoggingUnitTests
{


    /// <summary>
    ///This is a test class for DateRolloverStrategyTest and is intended
    ///to contain all DateRolloverStrategyTest Unit Tests
    ///</summary>
    [TestClass()]
    public class DateRolloverStrategyTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for GetRolledFileName, just file name
        ///</summary>
        [TestMethod()]
        public void GetRolledFileNameTest1()
        {
            DateRolloverStrategy target = new DateRolloverStrategy();
            string fileName = "GetRolledFileNameTest1.txt";
            string expected = ReturnExpectedFileName(fileName);
            string actual;
            actual = target.GetRolledFileName(fileName);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for GetRolledFileName, file name and path.
        ///</summary>
        [TestMethod()]
        public void GetRolledFileNameTest2()
        {
            DateRolloverStrategy target = new DateRolloverStrategy();
            string fileName = System.IO.Path.Combine(System.IO.Path.GetTempPath(), "GetRolledFileNameTest2.txt");
            string expected = ReturnExpectedFileName(fileName);
            string actual;
            actual = target.GetRolledFileName(fileName);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for GetRolledFileName, file name and path with no extension.
        ///</summary>
        [TestMethod()]
        public void GetRolledFileNameTest3()
        {
            DateRolloverStrategy target = new DateRolloverStrategy();
            string fileName = System.IO.Path.Combine(System.IO.Path.GetTempPath(), "GetRolledFileNameTest3");
            string expected = ReturnExpectedFileName(fileName);
            string actual;
            actual = target.GetRolledFileName(fileName);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for GetRolledFileName, file name only with no extension.
        ///</summary>
        [TestMethod()]
        public void GetRolledFileNameTest4()
        {
            DateRolloverStrategy target = new DateRolloverStrategy();
            string fileName = "GetRolledFileNameTest3";
            string expected = ReturnExpectedFileName(fileName);
            string actual;
            actual = target.GetRolledFileName(fileName);
            Assert.AreEqual(expected, actual);
        }


        #region Private Methods

        private string ReturnExpectedFileName(string fileName)
        {
            string ext = System.IO.Path.GetExtension(fileName);
            return fileName.Substring(0, fileName.Length - ext.Length) + DateTime.Today.ToString("yyyyMMdd") + ext;
        }
    }

        #endregion
}
