﻿using tpts.Logging;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Diagnostics.Contracts;

namespace tptsLoggingUnitTests
{


    /// <summary>
    ///This is a test class for SeverityFilterTest and is intended
    ///to contain all SeverityFilterTest Unit Tests
    ///</summary>
    [TestClass()]
    public class SeverityFilterTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        /// Constructor for SeverityFilterTest
        /// </summary>
        public SeverityFilterTest()
        {
            // Add event handler for contract failures, required so tests can trap any contract exceptions
            // Required to allow unit tests to test contracts are correct.
            Contract.ContractFailed += (sender, e) =>
            {
                e.SetHandled();
                e.SetUnwind();
                throw new ContractTestFailedException(e.FailureKind + ": " + e.Message);
            };
        }

        #region Test Constructors

        ///// <summary>
        ///// Tets constructor for all severity values and for filter for type string.
        ///// </summary>
        //[TestMethod()]
        //public void ConstructorTest1()
        //{
        //    foreach (LogEntrySeverity severityThreshold in Enum.GetValues(typeof(LogEntrySeverity)))
        //    {
        //        SeverityFilter<string> target = new SeverityFilter<string>(severityThreshold);
        //        LogEntrySeverity actual;
        //        actual = target.SeverityThreshold;
        //        Assert.AreEqual(severityThreshold, actual);

        //    }
        //}

        ///// <summary>
        ///// Tets constructor for all severity values and for filter for type LogEntryType.
        ///// </summary>
        //[TestMethod()]
        //public void ConstructorTest2()
        //{
        //    foreach (LogEntrySeverity severityThreshold in Enum.GetValues(typeof(LogEntrySeverity)))
        //    {
        //        SeverityFilter<LogEntryType> target = new SeverityFilter<LogEntryType>(severityThreshold);
        //        LogEntrySeverity actual;
        //        actual = target.SeverityThreshold;
        //        Assert.AreEqual(severityThreshold, actual);

        //    }
        //}

        #endregion

        #region Test Methods

        /// <summary>
        ///A test for Accept, loop through all values for severity enum and check accept returns the correct value.
        ///</summary>
        [TestMethod()]
        public void AcceptTest1()
        {
            foreach (LogEntrySeverity severityThreshold in Enum.GetValues(typeof(LogEntrySeverity)))
            {
                foreach (LogEntrySeverity logEntrySeverity in Enum.GetValues(typeof(LogEntrySeverity)))
                {
                    SeverityFilter<LogEntryType> target = new SeverityFilter<LogEntryType>(severityThreshold);
                    LogEntryType leType = new LogEntryType();
                    LogEntry<LogEntryType> logEntry = new LogEntry<LogEntryType>(DateTime.Now, leType, logEntrySeverity, "");
                    bool actual;
                    bool expected = (logEntrySeverity >= severityThreshold);
                    actual = target.Accept(logEntry);
                    Assert.AreEqual(expected, actual, "Filter:" + severityThreshold.ToString() + ", log entry:" + logEntrySeverity.ToString());
                }
            }
        }

        /// <summary>
        ///A test for Accept, loop through all values for severity enum and check accept returns the correct value.
        ///</summary>
        [TestMethod()]
        public void AcceptTest2()
        {
            foreach (LogEntrySeverity severityThreshold in Enum.GetValues(typeof(LogEntrySeverity)))
            {
                foreach (LogEntrySeverity logEntrySeverity in Enum.GetValues(typeof(LogEntrySeverity)))
                {
                    SeverityFilter<string> target = new SeverityFilter<string>(severityThreshold);
                    LogEntry<string> logEntry = new LogEntry<string>(DateTime.Now, "Test Entry", logEntrySeverity, "");
                    bool actual;
                    bool expected = (logEntrySeverity >= severityThreshold);
                    actual = target.Accept(logEntry);
                    Assert.AreEqual(expected, actual, "Filter:" + severityThreshold.ToString() + ", log entry:" + logEntrySeverity.ToString());
                }
            }
        }

        #endregion

        #region Test Properties

        #endregion

        #region Contract Tests

        #endregion
    }
}
