﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using tpts.Logging;


namespace tptsLoggingUnitTests
{
    class GenericLogger<T> : Logger<T>
    {

        private int _LoggedCount = 0;

        /// <summary>
        /// Returns the number of times Log was called on this logger.
        /// </summary>
        public int LoggedCount
        {
            get { return _LoggedCount; }
        }


        public string LoggerName { get; set; } // Allow logger instances to be identified for debugging purposes.

        public override string ToString()
        {
            if (LoggerName == null)
            {
                return base.ToString();
            }
            else
            {
                return base.ToString() + ":" + LoggerName;
            }
        }

        protected override bool Log(LogEntry<T> logEntry)
        {
            _LoggedCount += 1;
            // Check log entry matches filter.
            if (CheckFilter(logEntry))
            {
                // Apply formatting
                string formattedEntry = FormatEntry(logEntry);

                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
