﻿using tpts.Logging;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace tptsLoggingUnitTests
{
    
    
    /// <summary>
    ///This is a test class for XMLLogEntryFormatterTest and is intended
    ///to contain all XMLLogEntryFormatterTest Unit Tests
    ///</summary>
    [TestClass()]
    public class XMLLogEntryFormatterTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for FormatEntry
        ///</summary>
        [TestMethod()]
        public void FormatEntryTest()
        {
            XMLLogEntryFormatter<string> target = new XMLLogEntryFormatter<string>();
            string entryText = "XML FormatEntryTest";
            string category = "XML Category";
            LogEntrySeverity severity = LogEntrySeverity.Critical;
            DateTime logDateTime = DateTime.Now;
            LogEntry<string> logEntry = new LogEntry<string>(logDateTime, entryText, severity, category);
            string actual;
            actual = target.FormatEntry(logEntry);
            Assert.IsTrue(actual.ToLower().Contains("<category>"), "Missing Category Element");
            Assert.IsTrue(actual.ToLower().Contains("<severity>"), "Missing Severity Element");
            Assert.IsTrue(actual.ToLower().Contains("<entry>"), "Missing Entry Element");
            Assert.IsTrue(actual.ToLower().Contains("<loggedat>"), "Missing LoggedAt Element");
            Assert.IsTrue(actual.Contains(category), "Missing Category Value");
            Assert.IsTrue(actual.Contains(severity.ToString()), "Missing Severity Value");
            Assert.IsTrue(actual.Contains(entryText), "Missing Entry Value");
            Assert.IsTrue(actual.Contains(logDateTime.ToString("G")), "Missing LoggedAt Value");
        }
    }
}
